
% propagate and search 

% Find a rectangle whose perimeter is 20 and area greater than or
% equal to 24, and width is less than height.
% Find W,H so that (W+H = 10) ^ (W*H >=24) ^ (W < H)

declare
fun {Rectangle}
   W H in
   W::0#9   H::0#9
   W+H =: 10
   W*H >=: 24
   W <: H
   {FD.distribute naive rect(W H)}
   rect(W H)
end

{Browse {Search.base.all Rectangle}}

declare
fun {Palindrome}
   A B C X Y in
   A::1000#9999   B::0#99 C::0#99
   A =: B*C
   X::1#9   Y::0#9
   A =: X*1000+Y*100+Y*10+X
   {FD.distribute ff [X Y]}
   A
end
{Browse {Search.base.all Palindrome}}  		% 36 solutions
